//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//
//
// Common functions used in various flockWebServices, collected here for your (well, really my) convenience
//

//Stolen from flock code
function dd(obj) {
    for (p in obj) {
        try {
            debug(obj + '.' + p + ' :: ' + obj[p] + '\n');
            if (typeof obj[p] == 'object') {
                for (q in obj[p]) {
                    debug(obj + '.' + p + '.' + q + ' :: ' + obj[p][q] + '\n');
                    if (typeof obj[p][q] == 'object') {
                        for (r in obj[p][q]) {
                            debug(obj + '.' + p + '.' + q + '.' + r + ' :: ' + obj[p][q][r] + '\n');
                            if (typeof obj[p][q][r] == 'object') {
                                for (s in obj[p][q][r]) {
                                    debug(obj + '.' + p + '.' + q + '.' + r + '.' + s + ' :: ' + obj[p][q][r][s] + '\n');
                                }
                            }
                        }
                    }
                }
            }
        } catch(e) {
            continue;
        }
    }
}

function traced(obj) {
    for (p in obj) {
        try {
            inform(obj + '.' + p + ' :: ' + obj[p] + '\n');
            if (typeof obj[p] == 'object') {
                for (q in obj[p]) {
                    inform(obj + '.' + p + '.' + q + ' :: ' + obj[p][q] + '\n');
                    if (typeof obj[p][q] == 'object') {
                        for (r in obj[p][q]) {
                            inform(obj + '.' + p + '.' + q + '.' + r + ' :: ' + obj[p][q][r] + '\n');
                            if (typeof obj[p][q][r] == 'object') {
                                for (s in obj[p][q][r]) {
                                    inform(obj + '.' + p + '.' + q + '.' + r + '.' + s + ' :: ' + obj[p][q][r][s] + '\n');
                                    if (typeof obj[p][q][r][s] == 'object') {
                                        for (t in obj[p][q][r][s]) {
                                            inform(obj + '.' + p + '.' + q + '.' + r + '.' + s + '.' + t + ' :: ' + obj[p][q][r][s][t] + '\n');
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } catch(e) {
            continue;
        }
    }
}

// CONSTANTS {{{
const flockIFavoritesWebService = Components.interfaces.flockIFavoritesWebService;
const flockIFavoritesChange = Components.interfaces.flockIFavoritesChange;
const flockIFavoritesQueue = Components.interfaces.flockIFavoritesQueue;
const flockIFavoritesUtils = Components.interfaces.flockIFavoritesUtils;
const flockIFavoritesService = Components.interfaces.flockIFavoritesService;
const flockIFavoriteProperties = Components.interfaces.flockIFavoriteProperties;
const nsISupports = Components.interfaces.nsISupports;
const nsITimer = Components.interfaces.nsITimer;
const nsITimerCallback = Components.interfaces.nsITimerCallback;
const nsIXMLHttpRequest = Components.interfaces.nsIXMLHttpRequest;
const nsIPasswordManager = Components.interfaces.nsIPasswordManager;
const nsIPassword = Components.interfaces.nsIPassword;
const nsIDOMSerializer = Components.interfaces.nsIDOMSerializer;
const nsIPrefBranch              = Components.interfaces.nsIPrefBranch;
const nsIPromptService = Components.interfaces.nsIPromptService;

const TIMER_CONTRACTID = '@mozilla.org/timer;1';
const XMLHTTPREQUEST_CONTRACTID = '@mozilla.org/xmlextras/xmlhttprequest;1';
const PASSWORDMANAGER_CONTRACTID = '@mozilla.org/passwordmanager;1';
const XMLSERIALIZER_CONTRACTID = '@mozilla.org/xmlextras/xmlserializer;1';
const FFS_CONTRACTID = '@mozilla.org/rdf/datasource;1?name=flock-favorites';
const PREFERENCES_CONTRACTID = '@mozilla.org/preferences-service;1';
const PROMPT_CONTRACTID = '@mozilla.org/embedcomp/prompt-service;1';

const PREFS = Components.classes[PREFERENCES_CONTRACTID].getService (nsIPrefBranch);

const DIRECTION_TO_WEB_SERVICE = flockIFavoritesQueue.DIRECTION_TO_WEB_SERVICE;
const DIRECTION_FROM_WEB_SERVICE = flockIFavoritesQueue.DIRECTION_FROM_WEB_SERVICE;

const FIELD_WSID                 = flockIFavoriteProperties.FIELD_WSID;
const FIELD_TAGS                 = flockIFavoriteProperties.FIELD_TAGS;
const FIELD_PERMISSIONS          = flockIFavoriteProperties.FIELD_PERMISSIONS;
const FIELD_NAME                 = flockIFavoriteProperties.FIELD_NAME;
const FIELD_SHORTCUTURL          = flockIFavoriteProperties.FIELD_SHORTCUTURL;
const FIELD_DESCRIPTION          = flockIFavoriteProperties.FIELD_DESCRIPTION;
const FIELD_NSYNC                = flockIFavoriteProperties.FIELD_NSYNC;
const FIELD_LASTVISITDATE        = flockIFavoriteProperties.FIELD_LASTVISITDATE;
const FIELD_LASTMODIFIEDDATE     = flockIFavoriteProperties.FIELD_LASTMODIFIEDDATE;
const FIELD_ADDEDDATE            = flockIFavoriteProperties.FIELD_ADDEDDATE;

const TIMEOUT = 10; // cancel requests that take more than 10 seconds 

const SEND_WAIT = 1; // wait one second between sending updates
const RECV_WAIT = 60*5; // wait 

/// }}}

function loadLibrary(aFilename) { // {{{
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties)
        .get("ComsD", Components.interfaces.nsIFile);
    file.append(aFilename);

    var ios = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    var spec = fileHandler.getURLSpecFromFile(file);

    var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
        .getService(Components.interfaces.mozIJSSubScriptLoader);

    scriptLoader.loadSubScript(spec);
}
// }}}

// load the XPCOM template library
loadLibrary("flockXPCOMTemplate.js.lib");

// load the xmlrpc helper library
loadLibrary ('flockXmlRpcHelper.js.lib');
