/*  *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code Shadows.com API client implementation.
 *
 * The Initial Developer of the Original Code is
 * Pluck Corporation. This code is Copyright (C) 2005, 2006
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Carl Brown (carlb@shadows.com)
 *   Duane Fields (dfields@pluck.com)
 *
 * ***** END LICENSE BLOCK ***** */


shadows.getInfoForUrl = function (aURLArray, fnCallBack) {

    debug('getInfoForUrl: called with \n');
    debug('getInfoForUrl: aURL Array "' + aURLArray + '"\n');
    this.mgetInfoForUrlRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("shadowpage"));
    
    debug('getInfoForUrl: XMLRPCUrl "' + shadows.XmlRpc.Url("shadowpage") + '"\n');

    var args = [aURLArray];
        
    debug('getInfoForUrl: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('getInfoForUrl: result \n');
        debug('getInfoForUrl: returning "' + aResult + '"\n');
        debug('getInfoForUrl: returning "' + aResult['Response'] + '"\n');
        debug('getInfoForUrl: returning "' + aResult['Response']['OverallStatus'] + '"\n');
        debug('getInfoForUrl: returning "' + aResult['Response']['OverallStatus']['Entry'] + '"\n');
        debug('getInfoForUrl: returning "' + aResult['Response']['OverallStatus']['Entry']['Status'] + '"\n');
        dd (aResult);
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('getInfoForUrl: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }

    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('getInfoForUrl: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mgetInfoForUrlRPC.call ('shadows.public.urlinfo.get', args, listener);

    return true;
}

shadows.getCommentsForUrl = function (aURLArray, fnCallBack) {

    debug('getCommentsForUrl: called with \n');
    debug('getCommentsForUrl: aURL Array "' + aURLArray + '"\n');
    this.mgetCommentsForUrlRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("shadowpage"));
    
    debug('getCommentsForUrl: XMLRPCUrl "' + shadows.XmlRpc.Url("shadowpage") + '"\n');

    var args = [aURLArray];
        
    debug('getCommentsForUrl: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('getCommentsForUrl: result \n');
        debug('getCommentsForUrl: returning "' + aResult + '"\n');
        debug('getCommentsForUrl: returning "' + aResult['Response'] + '"\n');
        debug('getCommentsForUrl: returning "' + aResult['Response']['OverallStatus'] + '"\n');
        debug('getCommentsForUrl: returning "' + aResult['Response']['OverallStatus']['Entry'] + '"\n');
        debug('getCommentsForUrl: returning "' + aResult['Response']['OverallStatus']['Entry']['Status'] + '"\n');
        dd (aResult);
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('getCommentsForUrl: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }

    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('getCommentsForUrl: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mgetCommentsForUrlRPC.call ('shadows.public.urlcomments.get', args, listener);

    return true;
}
