// vim: foldmethod=marker

var favoritesMenuController = new CommandController({
    // all the commands
    cmd_favoriteCreateCurrentButton: function (aEvt) {/*{{{*/
        XXX('CREATE CURRENT BUTTON');
        if (flock_getBoolPref('flock.favorites.addAndTagByDefault')) {
            flock.command('cmd_favoriteCreateCurrentDetailed');
        } else {
           flock.command('cmd_favoriteCreateCurrent');
        }
        if (!flock_getBoolPref('flock.favorites.firstTimeSharing') &&
            flock_getCharPref('flock.favorites.webservice.id') == '') {
            var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
            var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
            var stringBundle = stringBundleService.createBundle("chrome://flock/locale/favorites/favorites.properties", localeService.getApplicationLocale());
            gBrowser.showMessage(
                gBrowser.selectedBrowser, 
                null, 
                stringBundle.GetStringFromName("flock.favorites.tip"),
                stringBundle.GetStringFromName("flock.favorites.tip.config"),
                "",
                "favorites-sharing",
                null,
                "top",
                true
            );
            flock_setBoolPref('flock.favorites.firstTimeSharing', true);
        }
    },/*}}}*/
    cmd_favoriteCreateCurrent: function () {/*{{{*/
        var fav = flock.favorites.currentAsFavorite;
        fav = flock.favorites.updateOrCreateFavorite(fav);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_favoriteCreateCurrentDetailed: function () {/*{{{*/
        var fav = flock.favorites.currentAsFavorite;
        fav = flock.favorites.updateOrCreateFavorite(fav, true);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_favoriteGoManager: function (aCollection, aFilter) {/*{{{*/
        var collection = aCollection;
        if (!collection) {
            collection = "http://flock.com/rdf#FavoritesRoot";
        }
        collection = escape(collection);
        var url = 'chrome://browser/content/flock/favorites/favoritesManager.xul?collection=' + collection;
        if (aFilter) url += "&filter=" + escape(aFilter);
    
        flock.browser.open(url, 'foreground_tab');
    },/*}}}*/
    cmd_favoriteGoWebService: function () {/*{{{*/
        var wsUrl = flock.favorites.webService.webView;
        if (wsUrl) {
            flock.browser.open(wsUrl);
        }
    },/*}}}*/
    cmd_favoriteEdit: function (aUrl) {/*{{{*/
        flock.favorites.editItem({url:aUrl});
    },/*}}}*/
    cmd_favoriteRemove: function (aUrl, aParent) {/*{{{*/
        flock.favorites.removeItemFromParent(aUrl, aParent);
    },/*}}}*/
    cmd_favoriteRemoveCurrent: function () {/*{{{*/
        var fav = flock.favorites.currentAsFavorite;
        flock.favorites.removeItemFromParent(fav.url);
        this.fireUpdate();
    },/*}}}*/
    cmd_favoriteCopy: function (aUrl) {/*{{{*/
        // this is fairly weak for now, just handling url
        var fav = flock.favorites.getFavorite(aUrl);

//      var trans = new flock.xpcom.Transferable(fav);
//      flock.xpcom.setClipboardData(trans);

 // XXX the following is from bookmarks.js since the above two lines do not
 //     work on either windows or linux and after wasting a lot of time it is
 //     easier just to impliment the feature here instead of figuring out why it
 //     does not work in xpcom.js - feel free to debug the previous two lines and
 //     remove this code, just make sure to test on all platforms - ja

        const kSuppWStringContractID = "@mozilla.org/supports-string;1";
        const kSuppWStringIID = Components.interfaces.nsISupportsString;
        var unicodestring = Components.classes[kSuppWStringContractID].createInstance(kSuppWStringIID);
        var htmlstring = Components.classes[kSuppWStringContractID].createInstance(kSuppWStringIID);
       
        const kXferableContractID = "@mozilla.org/widget/transferable;1";
        const kXferableIID = Components.interfaces.nsITransferable;
        var xferable = Components.classes[kXferableContractID].createInstance(kXferableIID);
       
        xferable.addDataFlavor("text/html");
        htmlstring.data = "<A HREF=\"" + aUrl + "\">" + fav.name + "</A>";
        xferable.setTransferData("text/html", htmlstring, htmlstring.data.length*2);
       
        xferable.addDataFlavor("text/unicode");
        unicodestring.data = aUrl;
        xferable.setTransferData("text/unicode", unicodestring, unicodestring.data.length*2);
       
        const kClipboardContractID = "@mozilla.org/widget/clipboard;1";
        const kClipboardIID = Components.interfaces.nsIClipboard;
        var clipboard = Components.classes[kClipboardContractID].getService(kClipboardIID);
        clipboard.setData(xferable, null, kClipboardIID.kGlobalClipboard);
    },/*}}}*/
    cmd_favoriteRefreshFeeds: function (aUrl) {/*{{{*/
        flock.favorites.refreshFeeds([aUrl]);
    },/*}}}*/
    cmd_favoriteViewFeeds: function (aUrl) {/*{{{*/
        flock.favorites.viewFeeds([aUrl]);
    },/*}}}*/
    cmd_collectionCreateFromTabs: {/*{{{*/
        exec: function () {
        // if tabs and valid
        // f.fav.createCollectionFrom(tabUrls)
        this.fireUpdate();
        },
    },/*}}}*/
    cmd_collectionOpenInTabs: function (aCollection) {/*{{{*/
        flock.favorites.openCollectionInTabs(aCollection);
    },/*}}}*/
    cmd_viewFeedsViewOptionsMenu: function() {/*{{{*/
        $('favoritesFeedButton').firstChild.showPopup($('favoritesFeedBox'), -1, -1, 'popup', 'bottomleft', 'topleft');
    },   /*}}}*/
    cmd_collectionAddCurrent: function (aEvent) {/*{{{*/
        XXX('COLLECTION TO ADD TO', aEvent.target.getAttribute('label'));
        var collection = aEvent.target.getAttribute('label');
        var fav = flock.favorites.currentAsFavorite;
        flock.favorites.addItemToCollection(
            fav,
            collection
        );
        fav = flock.favorites.getFavorite(fav);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_collectionAddCurrentToNew: function () {/*{{{*/
        var fav = flock.favorites.currentAsFavorite;
        var col = flock.favorites.createCollectionFrom(
            [flock.favorites.currentAsFavorite]
        );
        if (!col) return;
        fav = flock.favorites.getFavorite(fav);
        if (fav && flock.browser.currentFeeds) {
            flock.favorites.updateFeedsForFavorite(
                flock.browser.currentFeeds,
                fav
            );
        }
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_collectionAddCurrentTabsToNew: function () {/*{{{*/
        XXX('ADDING CURRENT TABS TO NEW COLLECTION!');
        //return;
        var tabs = flock.browser.currentTabs;
        var o = [];
        for (var i = 0; i < tabs.length; ++i) {
            var tab = tabs[i];
            var b = tab.linkedBrowser;
            var f = {
                name: b.contentTitle,
                url: b.currentURI.spec || "Untitled",
                feed: (b.currentURI.spec.match(/^feed/)
                        || flock.favorites.isFeedDocument(b.docShell.document)),
                browser: b,
            };
            o.push(f);
        }
        var rv = flock.favorites.createCollectionFrom(o);
        if (!rv) return;
        o.forEach(function (aFav) {
            var feeds = aFav.browser.feeds;
            if (!feeds) return;
            var dummy = {};
            var goodFeeds = flock.feed.service.prioritizeFeedsQuick(
                feeds.length,
                feeds,
                dummy
            );
            goodFeeds = goodFeeds.map(function (aVal) {
                return {
                    url: aVal.href,
                    name: aVal.title,
                    type: aVal.type
                };
            });
            flock.favorites.updateFeedsForFavorite(
                goodFeeds,
                aFav.url
            );
        });
        
        
        this.fireUpdate();
        return;
    },/*}}}*/
    cmd_viewFeedsToggle: function () {/*{{{*/
        if (!flock.browser.isFeedView) {
            flock.browser.openFeeds(gWebProgressListener.verifiedFeeds[gWebProgressListener.currentUrl]);
        }
    },/*}}}*/
    cmd_itemOpen: function (aEvent, aWhere) {/*{{{*/
        if (typeof aEvent == "string") {
            var url = aEvent;
        }
        else {
            var item = aEvent.originalTarget;
            var url = item.getAttribute('url');
            while (!url) {
                item = item.parentNode;
                url = item.getAttribute('url');
            }
        }
        var where = aWhere;
        if (!where) {
            where = 'current';
            if (aEvent.metaKey || aEvent.ctrlKey || aEvent.button == 1) {
                where = "tab";
            }
        }
        if (flock.favorites.isFeed(url)) {
            flock.browser.openFeeds([url], where);
        }
        else {
            flock.browser.open(url, where);
        }
    },/*}}}*/

    // enable/disable stuff
    onPopupShowing: function (aEvent) {/*{{{*/
        this.updateValidUrl();
        this.updateWebService();
        this.updateTabs();
    },/*}}}*/
    updateValidUrl: function () {/*{{{*/
        if (flock.browser.mostRecentNavigator) {
            flock.xul.enable($('bcast_favoriteValidUrl'));   
        }
        else {
            flock.xul.disable($('bcast_favoriteValidUrl'));   
        }
    },/*}}}*/
    updateWebService: function () {/*{{{*/
        if (flock.favorites.service.webService) {
            flock.xul.enable($('cmd_favoriteGoWebService'));
        } 
        else {
            flock.xul.disable($('cmd_favoriteGoWebService'));
        }
    },/*}}}*/
    updateTabs: function () {/*{{{*/
        XXX("UPDATING TABBSS");
        if (flock.browser.currentTabs.length > 1) {
            XXX('TABS', flock.browser.currentTabs.length);
            flock.xul.enable($('bcast_browserHasTabs'));
        }
        else {
            flock.xul.disable($('bcast_browserHasTabs'));
        }
    },/*}}}*/
    
    // hits an observer
    fireUpdate: function () {/*{{{*/
        XXX('fireUpdate');
        // going to put a favicon load call, just 'cause
        // XXX andy: this could theoretically fail
        try {
            var currentBrowser = flock.browser.currentBrowser;
            flock.favorites.loadFavIcon(currentBrowser.currentURI.spec, currentBrowser.mIconURL);
        } catch (e) {
            dd(e);
        }

        // grab observer service
        // notify favorites:update
        flock.xpcom.notifyObservers('favorites', 'favorites:update');
    },/*}}}*/

    // for the collection flyouts...
    onCollectionPopupShowing: function (aEvt) {/*{{{*/
        var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
        var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
        var stringBundle = stringBundleService.createBundle("chrome://flock/locale/favorites/favorites.properties", localeService.getApplicationLocale());
        var popup = aEvt.target;
        var existing = popup.getElementsByAttribute('addon','true');
        var existing = flock.lang.toArray(existing);
        for (var i = 0; i < existing.length; ++i) {
            var item = existing[i];
            popup.removeChild(item);
        }
        var sep = flock.xul.createElement('menuseparator', {
            addon: "true",
        });
        var openInTabs = flock.xul.createElement('menuitem', {
            label: stringBundle.GetStringFromName("flock.favorites.openInTabs"),
            addon: "true",
            oncommand: "XXX(this.parentNode.localName, this.parentNode.parentNode.localName); flock.command('cmd_collectionOpenInTabs', this.parentNode.parentNode.id); event.preventBubble();"
        });
        var col = flock.favorites.getCollection(popup.parentNode.id);
        if (!col.items.length) openInTabs.setAttribute("disabled", "true");
        
        popup.appendChild(sep);
        popup.appendChild(openInTabs);
    },/*}}}*/
});


function onLoad_favoritesMenu() {/*{{{*/
    window.controllers.appendController(favoritesMenuController);
}/*}}}*/

function updateDiscoveredFeedsPopup() {/*{{{*/
	var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
	var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var stringBundle = stringBundleService.createBundle("chrome://flock/locale/favorites/favorites.properties", localeService.getApplicationLocale());
	var discoveredFeeds = gWebProgressListener.discoveredFeeds[gWebProgressListener.currentUrl];
	var verifiedFeeds = gWebProgressListener.verifiedFeeds[gWebProgressListener.currentUrl];
    var feedButton = $('favoritesFeedButton');
	var nodeList = feedButton.firstChild.childNodes;
	var nodeCount = nodeList.length;
	for (var c = 0; c < nodeCount; c++) {
		feedButton.firstChild.removeChild(nodeList.item(0));
	}

	var newMenuItem;
	
	for (url in discoveredFeeds) {
		for (var c = 0; c < verifiedFeeds.length; c++) {
			if (verifiedFeeds[c]["url"] == url) {
				if (flock.feed.service.isSubscription(verifiedFeeds[c]["url"])) {
					newMenuItem = flock.xul.createElement('menuitem', {
		                class: "flock-discovered-feeds-item menuitem-iconic", 
		                label: verifiedFeeds[c]["title"], 
		                oncommand: "flock.browser.openFeeds(['" + verifiedFeeds[c]['url'] + "']);",
		                image: "chrome://browser/skin/flock/feed/feed-subscribed.png",
		            });
				} else {
					newMenuItem = flock.xul.createElement('menuitem', {
		                class: "flock-discovered-feeds-item menuitem-iconic", 
		                label: verifiedFeeds[c]["title"], 
		                oncommand: "flock.browser.openFeeds(['" + verifiedFeeds[c]['url'] + "']);",
		                image: "chrome://browser/skin/flock/feed/feed.png",
		            });
				}
				feedButton.firstChild.appendChild(newMenuItem);
			}
		}
	}
}/*}}}*/

dojo.event.connect(window, 'onload', 'onLoad_favoritesMenu');

    
